diff --git a/src/zabbix_server/vmware/vmware.c b/src/zabbix_server/vmware/vmware.c
index 43dd9835e99..3379b506ac1 100644
--- a/src/zabbix_server/vmware/vmware.c
+++ b/src/zabbix_server/vmware/vmware.c
@@ -4510,25 +4713,20 @@ static int	vmware_service_get_hv_data(const zbx_vmware_service_t *service, CURL
 		if (0 != propmap[i].vc_min && propmap[i].vc_min > service->major_version * 10 + service->minor_version)
 			continue;
 
-		zbx_strlcat(props, "<ns0:pathSet>", sizeof(props));
-		zbx_strlcat(props, propmap[i].name, sizeof(props));
-		zbx_strlcat(props, "</ns0:pathSet>", sizeof(props));
+		zbx_strscat(props, "<ns0:pathSet>");
+		zbx_strscat(props, propmap[i].name);
+		zbx_strscat(props, "</ns0:pathSet>");
 	}
 
 	hvid_esc = zbx_xml_escape_dyn(hvid);
-
-	zbx_snprintf(tmp, sizeof(tmp), ZBX_POST_HV_DETAILS, vmware_service_objects[service->type].property_collector,
+	tmp = zbx_dsprintf(NULL, ZBX_POST_HV_DETAILS, vmware_service_objects[service->type].property_collector,
 			props, cq_prop, hvid_esc);
-
 	zbx_free(hvid_esc);
-
 	zabbix_log(LOG_LEVEL_TRACE, "%s() SOAP request: %s", __func__, tmp);
 
-	if (SUCCEED != zbx_soap_post(__func__, easyhandle, tmp, xdoc, NULL, error))
-		goto out;
+	ret = zbx_soap_post(__func__, easyhandle, tmp, xdoc, NULL, error);
+	zbx_str_free(tmp);
 
-	ret = SUCCEED;
-out:
 	zabbix_log(LOG_LEVEL_DEBUG, "End of %s():%s", __func__, zbx_result_string(ret));
 
 	return ret;
@@ -4759,126 +4957,524 @@ static int	vmware_service_hv_get_multipath_data(const zbx_vmware_service_t *serv
 
 /******************************************************************************
  *                                                                            *
- * Function: vmware_ds_uuid_compare                                           *
+ * Purpose: find DS by canonical disk name (perf counter instance)            *
  *                                                                            *
- * Purpose: sorting function to sort Datastore vector by uuid                 *
+ * Parameters: dss      - [IN] all known Datastores                           *
+ *             diskname - [IN] canonical disk name                            *
+ *                                                                            *
+ * Return value: uuid of Datastore or NULL                                    *
  *                                                                            *
  ******************************************************************************/
-int	vmware_ds_uuid_compare(const void *d1, const void *d2)
+static char	*vmware_datastores_diskname_search(const zbx_vector_vmware_datastore_t *dss, char *diskname)
 {
-	const zbx_vmware_datastore_t	*ds1 = *(const zbx_vmware_datastore_t * const *)d1;
-	const zbx_vmware_datastore_t	*ds2 = *(const zbx_vmware_datastore_t * const *)d2;
+	zbx_vmware_diskextent_t	dx_cmp = {.diskname = diskname};
+	int			i;
 
-	return strcmp(ds1->uuid, ds2->uuid);
+	for (i = 0; i< dss->values_num; i++)
+	{
+		zbx_vmware_datastore_t	*ds = dss->values[i];
+
+		if (FAIL == zbx_vector_vmware_diskextent_bsearch(&ds->diskextents, &dx_cmp,
+				ZBX_DEFAULT_STR_PTR_COMPARE_FUNC))
+		{
+			continue;
+		}
+
+		return zbx_strdup(NULL, ds->uuid);
+	}
+
+	return NULL;
 }
 
 /******************************************************************************
  *                                                                            *
- * Function: vmware_ds_name_compare                                           *
+ * Purpose: parse the vmware hypervisor internal disks details info           *
  *                                                                            *
- * Purpose: sorting function to sort Datastore vector by name                 *
+ * Parameters: xdoc       - [IN] a reference to xml document with disks info  *
+ *             dss        - [IN] all known Datastores                         *
+ *             disks_info - [OUT]                                             *
+ *                                                                            *
+ * Return value: count of updated disk objects                                *
  *                                                                            *
  ******************************************************************************/
-int	vmware_ds_name_compare(const void *d1, const void *d2)
+static int	vmware_service_hv_disks_parse_info(xmlDoc *xdoc, const zbx_vector_vmware_datastore_t *dss,
+		zbx_vector_ptr_pair_t *disks_info)
 {
-	const zbx_vmware_datastore_t	*ds1 = *(const zbx_vmware_datastore_t * const *)d1;
-	const zbx_vmware_datastore_t	*ds2 = *(const zbx_vmware_datastore_t * const *)d2;
+#	define SCSILUN_PROP_NUM		8
+#	define ZBX_XPATH_PSET		"/*/*/*/*/*/*[local-name()='propSet']"
+#	define ZBX_XPATH_LUN		"substring-before(substring-after(*[local-name()='name'],'\"'),'\"')"
+#	define ZBX_XPATH_LUN_PR_NAME	"substring-after(*[local-name()='name'],'\"].')"
 
-	return strcmp(ds1->name, ds2->name);
-}
 
-/******************************************************************************
- *                                                                            *
- * Purpose: sorting function to sort Datastore vector by id                   *
- *                                                                            *
- ******************************************************************************/
-static int	vmware_ds_id_compare(const void *d1, const void *d2)
-{
-	const zbx_vmware_datastore_t	*ds1 = *(const zbx_vmware_datastore_t * const *)d1;
-	const zbx_vmware_datastore_t	*ds2 = *(const zbx_vmware_datastore_t * const *)d2;
+	xmlXPathContext	*xpathCtx;
+	xmlXPathObject	*xpathObj;
+	xmlNodeSetPtr	nodeset;
+	char		*lun_key = NULL, *name = NULL;
+	int 		i, created = 0, j = FAIL;
 
-	return strcmp(ds1->id, ds2->id);
-}
 
-/******************************************************************************
- *                                                                            *
- * Purpose: sorting function to sort Datacenter vector by id                  *
- *                                                                            *
- ******************************************************************************/
-int	vmware_dc_id_compare(const void *d1, const void *d2)
-{
-	const zbx_vmware_datacenter_t	*dc1 = *(const zbx_vmware_datacenter_t * const *)d1;
-	const zbx_vmware_datacenter_t	*dc2 = *(const zbx_vmware_datacenter_t * const *)d2;
+	zabbix_log(LOG_LEVEL_DEBUG, "In %s()", __func__);
 
-	return strcmp(dc1->id, dc2->id);
-}
+	xpathCtx = xmlXPathNewContext(xdoc);
 
-/******************************************************************************
- *                                                                            *
- * Purpose: sorting function to sort custom attributes vector by name         *
- *                                                                            *
- ******************************************************************************/
-int	vmware_custom_attr_compare_name(const void *a1, const void *a2)
-{
-	const zbx_vmware_custom_attr_t	*attr1 = *(const zbx_vmware_custom_attr_t * const *)a1;
-	const zbx_vmware_custom_attr_t	*attr2 = *(const zbx_vmware_custom_attr_t * const *)a2;
+	if (NULL == (xpathObj = xmlXPathEvalExpression((const xmlChar *)ZBX_XPATH_PSET, xpathCtx)))
+		goto clean;
 
-	return strcmp(attr1->name, attr2->name);
-}
+	if (0 != xmlXPathNodeSetIsEmpty(xpathObj->nodesetval))
+		goto clean;
 
-/******************************************************************************
- *                                                                            *
- * Purpose: sorting function to sort DVSwitch vector by uuid                  *
- *                                                                            *
- ******************************************************************************/
-int	vmware_dvs_uuid_compare(const void *d1, const void *d2)
-{
-	const zbx_vmware_dvswitch_t	*dvs1 = *(const zbx_vmware_dvswitch_t * const *)d1;
-	const zbx_vmware_dvswitch_t	*dvs2 = *(const zbx_vmware_dvswitch_t * const *)d2;
+	nodeset = xpathObj->nodesetval;
+	zbx_vector_ptr_pair_reserve(disks_info, (size_t)(nodeset->nodeNr / SCSILUN_PROP_NUM + disks_info->values_num));
 
-	return strcmp(dvs1->uuid, dvs2->uuid);
-}
+	for (i = 0; i < nodeset->nodeNr; i++)
+	{
+		zbx_vmware_diskinfo_t	*di;
+		xmlNode			*node = nodeset->nodeTab[i];
+		zbx_ptr_pair_t		pr;
 
+		zbx_str_free(lun_key);
+		zbx_str_free(name);
 
-/******************************************************************************
- *                                                                            *
- * Purpose: sorting function to sort DVSwitch vector by uuid                  *
- *                                                                            *
- ******************************************************************************/
-static int	vmware_cq_instance_id_compare(const void *d1, const void *d2)
-{
-	int	ret;
+		if (NULL == (lun_key = zbx_xml_node_read_value(xdoc, node, ZBX_XPATH_LUN)))
+			continue;
 
-	const zbx_vmware_cq_value_t	*prop1 = (const zbx_vmware_cq_value_t *)d1;
-	const zbx_vmware_cq_value_t	*prop2 = (const zbx_vmware_cq_value_t *)d2;
+		if (NULL == (name = zbx_xml_node_read_value(xdoc, node, ZBX_XPATH_LUN_PR_NAME)))
+			continue;
 
-	if (0 == (ret = strcmp(prop1->instance->soap_type, prop2->instance->soap_type)))
-		ret = strcmp(prop1->instance->id, prop2->instance->id);
+		pr.first = lun_key;
 
-	return ret;
+		if ((FAIL == j || 0 != strcmp(disks_info->values[j].first, lun_key)) &&
+				FAIL == (j = zbx_vector_ptr_pair_search(disks_info, pr,
+				ZBX_DEFAULT_STR_COMPARE_FUNC)))
+		{
+			lun_key = NULL;
+			pr.second = zbx_malloc(NULL, sizeof(zbx_vmware_diskinfo_t));
+			memset(pr.second, 0, sizeof(zbx_vmware_diskinfo_t));
+			zbx_vector_ptr_pair_append(disks_info, pr);
+			j = disks_info->values_num - 1;
+			created++;
+		}
+
+		di = (zbx_vmware_diskinfo_t *)disks_info->values[j].second;
+
+		if (0 == strcmp(name, "canonicalName"))
+		{
+			di->diskname = zbx_xml_node_read_value(xdoc, node, ZBX_XNN("val"));
+			di->ds_uuid = vmware_datastores_diskname_search(dss, di->diskname);
+		}
+		else if (0 == strcmp(name, "operationalState"))
+		{
+			zbx_vector_str_t	values;
+			int			k;
+
+			zbx_vector_str_create(&values);
+			zbx_xml_node_read_values(xdoc, node, ZBX_XNN("val") "/*", &values);
+			di->operational_state = zbx_strdcat(di->operational_state, "[");
+
+			for (k = 0; k < values.values_num; k++)
+				di->operational_state = zbx_strdcatf(di->operational_state, "\"%s\",", values.values[k]);
+
+			if (0 != values.values_num)
+				di->operational_state[strlen(di->operational_state) - 1] = '\0';
+
+			di->operational_state = zbx_strdcat(di->operational_state, "]");
+			zbx_vector_str_clear_ext(&values, zbx_str_free);
+			zbx_vector_str_destroy(&values);
+		}
+		else if (0 == strcmp(name, "lunType"))
+		{
+			di->lun_type = zbx_xml_node_read_value(xdoc, node, ZBX_XNN("val"));
+		}
+		else if (0 == strcmp(name, "queueDepth"))
+		{
+			zbx_xml_node_read_num(xdoc, node, "number(" ZBX_XNN("val") ")", &di->queue_depth);
+		}
+		else if (0 == strcmp(name, "model"))
+		{
+			di->model = zbx_xml_node_read_value(xdoc, node, ZBX_XNN("val"));
+			zbx_lrtrim(di->model, " ");
+		}
+		else if (0 == strcmp(name, "vendor"))
+		{
+			di->vendor = zbx_xml_node_read_value(xdoc, node, ZBX_XNN("val"));
+			zbx_lrtrim(di->vendor, " ");
+		}
+		else if (0 == strcmp(name, "revision"))
+		{
+			di->revision = zbx_xml_node_read_value(xdoc, node, ZBX_XNN("val"));
+			zbx_lrtrim(di->revision, " ");
+		}
+		else if (0 == strcmp(name, "serialNumber"))
+		{
+			di->serial_number = zbx_xml_node_read_value(xdoc, node, ZBX_XNN("val"));
+			zbx_lrtrim(di->serial_number, " ");
+		}
+	}
+
+	zbx_str_free(lun_key);
+	zbx_str_free(name);
+clean:
+	xmlXPathFreeObject(xpathObj);
+	xmlXPathFreeContext(xpathCtx);
+
+	zabbix_log(LOG_LEVEL_DEBUG, "End of %s() created:%d", __func__, created);
+
+	return created;
+
+#	undef SCSILUN_PROP_NUM
+#	undef ZBX_XPATH_LUN_PR_NAME
+#	undef ZBX_XPATH_PSET
 }
 
 /******************************************************************************
  *                                                                            *
- * Purpose: populate array of values from an xml data                         *
+ * Purpose: parse the vmware hypervisor vsan disks details info               *
  *                                                                            *
- * Parameters: xdoc    - [IN] XML document                                    *
- *             ds_node - [IN] xml node with datastore info                    *
- *             ds_id   - [IN] datastore id (for logging)                      *
+ * Parameters: xdoc       - [IN] - a reference to xml document with disks info*
+ *             vsan_uuid  - [IN] - uuid of vsan DS                            *
+ *             disks_info - [IN/OUT] - collected the hv internal disks        *
  *                                                                            *
- * Return: bitmap value of HV access mode to DS                               *
+ * Return value: count of updated vsan disk objects                           *
  *                                                                            *
  ******************************************************************************/
-static zbx_uint64_t	vmware_hv_get_ds_access(xmlDoc *xdoc, xmlNode *ds_node, const char *ds_id)
+static int	vmware_service_hv_vsan_parse_info(xmlDoc *xdoc, const char *vsan_uuid,
+		zbx_vector_ptr_pair_t *disks_info)
 {
+	xmlXPathContext	*xpathCtx;
+	xmlXPathObject	*xpathObj;
+	xmlNodeSetPtr	nodeset;
+	int		i, updated_vsan = 0, j = FAIL;
 
-	zbx_uint64_t	mi_access = ZBX_VMWARE_DS_NONE;
-	char		*value;
+	zabbix_log(LOG_LEVEL_DEBUG, "In %s()", __func__);
 
-	zabbix_log(LOG_LEVEL_DEBUG, "In %s() for DS:%s", __func__, ds_id);
+	xpathCtx = xmlXPathNewContext(xdoc);
 
-	if (NULL != (value = zbx_xml_node_read_value(xdoc, ds_node, ZBX_XPATH_PROP_SUFFIX("mounted"))))
-	{
+	if (NULL == (xpathObj = xmlXPathEvalExpression((const xmlChar *)"//*[" ZBX_XNN("canonicalName") "]", xpathCtx)))
+		goto clean;
+
+	if (0 != xmlXPathNodeSetIsEmpty(xpathObj->nodesetval))
+		goto clean;
+
+	nodeset = xpathObj->nodesetval;
+
+	for (i = 0; i < nodeset->nodeNr; i++)
+	{
+		zbx_vmware_diskinfo_t	*di, di_cmp;
+		xmlNode			*mapinfo_node = nodeset->nodeTab[i];
+		zbx_ptr_pair_t		pr = {.first = NULL, .second = &di_cmp};
+
+		if (NULL == (di_cmp.diskname = zbx_xml_node_read_value(xdoc, mapinfo_node, ZBX_XNN("canonicalName"))) ||
+				FAIL == (j = zbx_vector_ptr_pair_bsearch(disks_info, pr,
+				vmware_diskinfo_diskname_compare)))
+		{
+			zabbix_log(LOG_LEVEL_DEBUG, "%s() skipped internal disk: %s", __func__,
+					ZBX_NULL2EMPTY_STR(di_cmp.diskname));
+			zbx_str_free(di_cmp.diskname);
+			continue;
+		}
+
+		zbx_str_free(di_cmp.diskname);
+		di = (zbx_vmware_diskinfo_t *)disks_info->values[j].second;
+		di->vsan = zbx_malloc(NULL, sizeof(zbx_vmware_vsandiskinfo_t));
+		memset(di->vsan, 0, sizeof(zbx_vmware_vsandiskinfo_t));
+		di->vsan->ssd = zbx_xml_node_read_value(xdoc, mapinfo_node, ZBX_XNN("ssd"));
+		di->vsan->local_disk = zbx_xml_node_read_value(xdoc, mapinfo_node, ZBX_XNN("localDisk"));
+		zbx_xml_node_read_num(xdoc, mapinfo_node,
+				"number(." ZBX_XPATH_LN2("capacity", "block") ")", (int *)&di->vsan->block);
+		zbx_xml_node_read_num(xdoc, mapinfo_node,
+				"number(." ZBX_XPATH_LN2("capacity", "blockSize") ")", (int *)&di->vsan->block_size);
+
+		if (NULL == di->ds_uuid)
+			di->ds_uuid = zbx_strdup(di->ds_uuid, vsan_uuid);
+
+		updated_vsan++;
+	}
+clean:
+	xmlXPathFreeObject(xpathObj);
+	xmlXPathFreeContext(xpathCtx);
+
+	zabbix_log(LOG_LEVEL_DEBUG, "End of %s() vsan disks updated:%d", __func__, updated_vsan);
+
+	return updated_vsan;
+}
+
+/******************************************************************************
+ *                                                                            *
+ * Purpose: gets the vmware hypervisor internal disks details info            *
+ *                                                                            *
+ * Parameters: service      - [IN] the vmware service                         *
+ *             easyhandle   - [IN] the CURL handle                            *
+ *             hv_data      - [IN] the hv data with scsi topology info        *
+ *             hvid         - [IN] the vmware hypervisor id                   *
+ *             dss          - [IN] all known Datastores                       *
+ *             vsan_uuid    - [IN] uuid of vsan Datastore                    *
+ *             disks_info   - [OUT]
+ *             error        - [OUT] the error message in the case of failure  *
+ *                                                                            *
+ * Return value: SUCCEED - the operation has completed successfully           *
+ *               FAIL    - the operation has failed                           *
+ *                                                                            *
+ ******************************************************************************/
+static int	vmware_service_hv_disks_get_info(const zbx_vmware_service_t *service, CURL *easyhandle,
+		xmlDoc *hv_data, const char *hvid, const zbx_vector_vmware_datastore_t *dss, const char *vsan_uuid,
+		zbx_vector_ptr_pair_t *disks_info, char **error)
+{
+#	define ZBX_POST_HV_DISK_INFO									\
+		ZBX_POST_VSPHERE_HEADER									\
+		"<ns0:RetrievePropertiesEx>"								\
+			"<ns0:_this type=\"PropertyCollector\">%s</ns0:_this>"				\
+			"<ns0:specSet>"									\
+				"<ns0:propSet>"								\
+					"<ns0:type>HostSystem</ns0:type>"				\
+					"%s"								\
+				"</ns0:propSet>"							\
+				"<ns0:objectSet>"							\
+					"<ns0:obj type=\"HostSystem\">%s</ns0:obj>"			\
+					"<ns0:skip>false</ns0:skip>"					\
+				"</ns0:objectSet>"							\
+			"</ns0:specSet>"								\
+			"<ns0:options/>"								\
+		"</ns0:RetrievePropertiesEx>"								\
+		ZBX_POST_VSPHERE_FOOTER
+
+#	define ZBX_POST_SCSI_INFO									\
+		"<ns0:pathSet>config.storageDevice.scsiLun[\"%s\"].canonicalName</ns0:pathSet>"		\
+		"<ns0:pathSet>config.storageDevice.scsiLun[\"%s\"].operationalState</ns0:pathSet>"	\
+		"<ns0:pathSet>config.storageDevice.scsiLun[\"%s\"].lunType</ns0:pathSet>"		\
+		"<ns0:pathSet>config.storageDevice.scsiLun[\"%s\"].queueDepth</ns0:pathSet>"		\
+		"<ns0:pathSet>config.storageDevice.scsiLun[\"%s\"].model</ns0:pathSet>"			\
+		"<ns0:pathSet>config.storageDevice.scsiLun[\"%s\"].vendor</ns0:pathSet>"		\
+		"<ns0:pathSet>config.storageDevice.scsiLun[\"%s\"].revision</ns0:pathSet>"		\
+		"<ns0:pathSet>config.storageDevice.scsiLun[\"%s\"].serialNumber</ns0:pathSet>"
+
+	zbx_vector_str_t		scsi_luns;
+	xmlDoc				*doc = NULL, *doc_dinfo = NULL;
+	zbx_property_collection_iter	*iter = NULL;
+	char				*tmp = NULL, *hvid_esc, *scsi_req = NULL, *err = NULL;
+	int				i, total, updated = 0, updated_vsan = 0, ret = SUCCEED;
+	const char			*pcollecter = vmware_service_objects[service->type].property_collector;
+
+	zabbix_log(LOG_LEVEL_DEBUG, "In %s() hvid:'%s'", __func__, hvid);
+
+	zbx_vector_str_create(&scsi_luns);
+	zbx_xml_read_values(hv_data, ZBX_XPATH_HV_SCSI_TOPOLOGY, &scsi_luns);
+	total = scsi_luns.values_num;
+	zabbix_log(LOG_LEVEL_DEBUG, "%s() count of scsiLun:%d", __func__, total);
+
+	if (0 == total)
+		goto out;
+
+	for (i = 0; i < scsi_luns.values_num; i++)
+	{
+		scsi_req = zbx_strdcatf(scsi_req , ZBX_POST_SCSI_INFO, scsi_luns.values[i], scsi_luns.values[i],
+				scsi_luns.values[i], scsi_luns.values[i], scsi_luns.values[i], scsi_luns.values[i],
+				scsi_luns.values[i], scsi_luns.values[i]);
+	}
+
+	zbx_vector_str_clear_ext(&scsi_luns, zbx_str_free);
+	hvid_esc = zbx_xml_escape_dyn(hvid);
+	tmp = zbx_dsprintf(NULL, ZBX_POST_HV_DISK_INFO, pcollecter, scsi_req, hvid_esc);
+	zbx_free(hvid_esc);
+	zbx_free(scsi_req);
+
+	if (SUCCEED != (ret = zbx_property_collection_init(easyhandle, tmp, pcollecter, &iter, &doc, error)))
+		goto out;
+
+	updated += vmware_service_hv_disks_parse_info(doc, dss, disks_info);
+
+	while (NULL != iter->token)
+	{
+		zbx_xml_free_doc(doc);
+		doc = NULL;
+
+		if (SUCCEED != (ret = zbx_property_collection_next(iter, &doc, error)))
+			goto out;
+
+		updated += vmware_service_hv_disks_parse_info(doc, dss, disks_info);
+	}
+
+	if (NULL == vsan_uuid)
+		goto out;
+
+	zbx_property_collection_free(iter);
+	iter = NULL;
+	zbx_vector_ptr_pair_sort(disks_info, vmware_diskinfo_diskname_compare);
+	hvid_esc = zbx_xml_escape_dyn(hvid);
+	tmp = zbx_dsprintf(NULL, ZBX_POST_HV_DISK_INFO, pcollecter ,
+			"<ns0:pathSet>config.vsanHostConfig.storageInfo.diskMapping</ns0:pathSet>", hvid_esc);
+	zbx_free(hvid_esc);
+
+	if (SUCCEED != (ret = zbx_property_collection_init(easyhandle, tmp, pcollecter, &iter, &doc_dinfo, &err)))
+	{
+		zabbix_log(LOG_LEVEL_DEBUG, "%s() cannot get vsan disk_info:%s", __func__, err);
+		zbx_str_free(err);
+		goto out;
+	}
+
+	updated_vsan += vmware_service_hv_vsan_parse_info(doc_dinfo, vsan_uuid, disks_info);
+
+	while (NULL != iter->token)
+	{
+		zbx_xml_free_doc(doc_dinfo);
+		doc_dinfo = NULL;
+
+		if (SUCCEED != (ret = zbx_property_collection_next(iter, &doc_dinfo, error)))
+			goto out;
+
+		updated_vsan += vmware_service_hv_vsan_parse_info(doc_dinfo, vsan_uuid, disks_info);
+	}
+out:
+	zbx_free(tmp);
+	zbx_xml_free_doc(doc);
+	zbx_xml_free_doc(doc_dinfo);
+	zbx_vector_str_destroy(&scsi_luns);
+	zbx_property_collection_free(iter);
+	zabbix_log(LOG_LEVEL_DEBUG, "End of %s():%s for %d(vsan:%d) / %d", __func__, zbx_result_string(ret), updated,
+			updated_vsan, total);
+
+	return ret;
+
+#	undef	ZBX_POST_SCSI_INFO
+#	undef	ZBX_POST_HV_DISK_INFO
+}
+
+/******************************************************************************
+ *                                                                            *
+ * Function: vmware_ds_uuid_compare                                           *
+ *                                                                            *
+ * Purpose: sorting function to sort Datastore vector by uuid                 *
+ *                                                                            *
+ ******************************************************************************/
+int	vmware_ds_uuid_compare(const void *d1, const void *d2)
+{
+	const zbx_vmware_datastore_t	*ds1 = *(const zbx_vmware_datastore_t * const *)d1;
+	const zbx_vmware_datastore_t	*ds2 = *(const zbx_vmware_datastore_t * const *)d2;
+
+	return strcmp(ds1->uuid, ds2->uuid);
+}
+
+/******************************************************************************
+ *                                                                            *
+ * Function: vmware_ds_name_compare                                           *
+ *                                                                            *
+ * Purpose: sorting function to sort Datastore vector by name                 *
+ *                                                                            *
+ ******************************************************************************/
+int	vmware_ds_name_compare(const void *d1, const void *d2)
+{
+	const zbx_vmware_datastore_t	*ds1 = *(const zbx_vmware_datastore_t * const *)d1;
+	const zbx_vmware_datastore_t	*ds2 = *(const zbx_vmware_datastore_t * const *)d2;
+
+	return strcmp(ds1->name, ds2->name);
+}
+
+/******************************************************************************
+ *                                                                            *
+ * Purpose: sorting function to sort Datastore vector by id                   *
+ *                                                                            *
+ ******************************************************************************/
+static int	vmware_ds_id_compare(const void *d1, const void *d2)
+{
+	const zbx_vmware_datastore_t	*ds1 = *(const zbx_vmware_datastore_t * const *)d1;
+	const zbx_vmware_datastore_t	*ds2 = *(const zbx_vmware_datastore_t * const *)d2;
+
+	return strcmp(ds1->id, ds2->id);
+}
+
+/******************************************************************************
+ *                                                                            *
+ * Purpose: sorting function to sort Datacenter vector by id                  *
+ *                                                                            *
+ ******************************************************************************/
+int	vmware_dc_id_compare(const void *d1, const void *d2)
+{
+	const zbx_vmware_datacenter_t	*dc1 = *(const zbx_vmware_datacenter_t * const *)d1;
+	const zbx_vmware_datacenter_t	*dc2 = *(const zbx_vmware_datacenter_t * const *)d2;
+
+	return strcmp(dc1->id, dc2->id);
+}
+
+/******************************************************************************
+ *                                                                            *
+ * Purpose: sorting function to sort custom attributes vector by name         *
+ *                                                                            *
+ ******************************************************************************/
+int	vmware_custom_attr_compare_name(const void *a1, const void *a2)
+{
+	const zbx_vmware_custom_attr_t	*attr1 = *(const zbx_vmware_custom_attr_t * const *)a1;
+	const zbx_vmware_custom_attr_t	*attr2 = *(const zbx_vmware_custom_attr_t * const *)a2;
+
+	return strcmp(attr1->name, attr2->name);
+}
+
+/******************************************************************************
+ *                                                                            *
+ * Purpose: sorting function to sort DVSwitch vector by uuid                  *
+ *                                                                            *
+ ******************************************************************************/
+int	vmware_dvs_uuid_compare(const void *d1, const void *d2)
+{
+	const zbx_vmware_dvswitch_t	*dvs1 = *(const zbx_vmware_dvswitch_t * const *)d1;
+	const zbx_vmware_dvswitch_t	*dvs2 = *(const zbx_vmware_dvswitch_t * const *)d2;
+
+	return strcmp(dvs1->uuid, dvs2->uuid);
+}
+
+
+/******************************************************************************
+ *                                                                            *
+ * Purpose: sorting function to sort DVSwitch vector by uuid                  *
+ *                                                                            *
+ ******************************************************************************/
+static int	vmware_cq_instance_id_compare(const void *d1, const void *d2)
+{
+	int	ret;
+
+	const zbx_vmware_cq_value_t	*prop1 = *(const zbx_vmware_cq_value_t * const *)d1;
+	const zbx_vmware_cq_value_t	*prop2 = *(const zbx_vmware_cq_value_t * const *)d2;
+
+	if (0 == (ret = strcmp(prop1->instance->soap_type, prop2->instance->soap_type)))
+		ret = strcmp(prop1->instance->id, prop2->instance->id);
+
+	return ret;
+}
+
+/******************************************************************************
+ *                                                                            *
+ * Purpose: sorting function to sort diskinfo vector by diskname              *
+ *                                                                            *
+ ******************************************************************************/
+static int	vmware_diskinfo_diskname_compare(const void *d1, const void *d2)
+{
+	const zbx_ptr_pair_t		*p1 = (const zbx_ptr_pair_t *)d1;
+	const zbx_ptr_pair_t		*p2 = (const zbx_ptr_pair_t *)d2;
+	const zbx_vmware_diskinfo_t	*di1 = (const zbx_vmware_diskinfo_t *)p1->second;
+	const zbx_vmware_diskinfo_t	*di2 = (const zbx_vmware_diskinfo_t *)p2->second;
+
+	return strcmp(di1->diskname, di2->diskname);
+}
+
+/******************************************************************************
+ *                                                                            *
+ * Purpose: populate array of values from an xml data                         *
+ *                                                                            *
+ * Parameters: xdoc    - [IN] XML document                                    *
+ *             ds_node - [IN] xml node with datastore info                    *
+ *             ds_id   - [IN] datastore id (for logging)                      *
+ *                                                                            *
+ * Return: bitmap value of HV access mode to DS                               *
+ *                                                                            *
+ ******************************************************************************/
+static zbx_uint64_t	vmware_hv_get_ds_access(xmlDoc *xdoc, xmlNode *ds_node, const char *ds_id)
+{
+
+	zbx_uint64_t	mi_access = ZBX_VMWARE_DS_NONE;
+	char		*value;
+
+	zabbix_log(LOG_LEVEL_DEBUG, "In %s() for DS:%s", __func__, ds_id);
+
+	if (NULL != (value = zbx_xml_node_read_value(xdoc, ds_node, ZBX_XPATH_PROP_SUFFIX("mounted"))))
+	{
 		if (0 == strcmp(value, "true"))
 			mi_access |= ZBX_VMWARE_DS_MOUNTED;
 
@@ -5252,6 +5848,7 @@ static int	vmware_hv_ds_access_update(zbx_vmware_service_t *service, CURL *easyh
 		ZBX_POST_VSPHERE_FOOTER
 
 	char				*hvid_esc, tmp[MAX_STRING_LEN];
+	const char			*pcollector = vmware_service_objects[service->type].property_collector;
 	int				ret = FAIL, updated = 0;
 	xmlDoc				*doc = NULL;
 	zbx_property_collection_iter	*iter = NULL;
@@ -5260,11 +5857,10 @@ static int	vmware_hv_ds_access_update(zbx_vmware_service_t *service, CURL *easyh
 			dss->values_num);
 
 	hvid_esc = zbx_xml_escape_dyn(hv_id);
-	zbx_snprintf(tmp, sizeof(tmp), ZBX_POST_HV_DS_ACCESS, vmware_service_objects[service->type].property_collector,
-			hvid_esc, hvid_esc, hvid_esc, hvid_esc);
+	zbx_snprintf(tmp, sizeof(tmp), ZBX_POST_HV_DS_ACCESS, pcollector, hvid_esc, hvid_esc, hvid_esc, hvid_esc);
 	zbx_free(hvid_esc);
 
-	if (SUCCEED != zbx_property_collection_init(easyhandle, tmp, "propertyCollector", &iter, &doc, error))
+	if (SUCCEED != zbx_property_collection_init(easyhandle, tmp, pcollector, &iter, &doc, error))
 		goto out;
 
 	updated += vmware_hv_ds_access_parse(doc, hv_dss, hv_uuid, hv_id, dss);
